"""
========================================
  Introduction to Computer Programming
========================================

-----------------------------------------------
  Lab 7
  timing tuples

  (starter file - remove this line once edited)
  <YOUR NAMES GO HERE>
-----------------------------------------------
"""


from random import randrange
from time import perf_counter_ns

from lab7_examples import *


# 0. use while loop to count to one million; print out elapsed time
def time_while_a_million():
    t0 = perf_counter_ns()
    ...
    print(f'while loop ... {...} nanoseconds')


# 1. same idea, but loop to n, do *not* print, but return elapsed time
#  examples:
#  >>> time_while(1000)
#      77333
#  >>> time_while(10**7)
#      259600375
#  (but your times may vary)
#
def time_while(n):
    ...
    return ...


# 2. use for loop, return pair
def count_less_more(stuff, x):
    """
    Returns pair of numbers indicating how many items in sequence (tuple,
    string, etc.) stuff are less than and how many are greater than x. Assumes
    the values in stuff are comparable to whatever x is.

    >>> count_less_more('VeryCool', 'e')
        (2, 5)
    >>> count_less_more((47, 63, 2, 34, 19), 50)
        (4, 1)
    """
    less = 0
    more = 0
    ...
    return (less, more)


# 3.
# returns a tuple of pairs (themselves tuples of length 2) of integers ranging
# between 0 and the x_limit for the first part of each pair and 0 and y_limit
# for the second; assumes x_limit and y_limit are positive integers
# visualize results using draw_points as in:
#
# >>> draw_points(random_points(50, COLUMNS, ROWS))
#
def random_points(n, x_limit, y_limit):
    points = ()
    ...
    return points


# 4. make use of divmod
def median(ns):
    """Returns the median of a nonempty tuple of numbers.

    >>> median((1, 2, 3, 4, 5))
    3
    >>> median((3, 5, 6, 15))   # even length: average middle numbers
    5.5
    >>> median((888, 7, 16, 491, 702))   # input need not be in order
    """
    ordered = selection_sort(ns)
    ...
    return ...


# 5.
# work from right (end) of xs toward left (beginning) until value less than x
# is found; use slicing and concatenation to do insertion; assume xs is a
# tuple of increasing values
def ordered_insert(xs, x):
    """
    Returns new tuple that is like xs but with x inserted into it so that xs is
    in increasing order; assumes xs is already in order.

    >>> ordered_insert((2, 3, 7), 5)
        (2, 3, 5, 7)
    >>> ordered_insert(('alpha', 'delta', 'gamma'), 'beta')
        ('alpha', 'beta', 'delta', 'gamma')
    """
    ...
    return ...


# 6.
# build new tuple by taking each item in xs and inserting it into the new
# tuple using ordered_insert
def insertion_sort(xs):
    """
    Returns new tuple that has same values of xs but is increasing order.

    >>> insertion_sort((5, 2, 7, 3))
        (2, 3, 5, 7)
    """
    ys = ()
    ...
    return ys


# 7.
# this is like Python's built-in split method for strings, though simplified
def split(s, ch):
    """
    Returns tuple of strings occurring in string s, separated by character ch.

    >>> split('able was I ere I saw Elba', ' ')
        ('able', 'was', 'I', 'ere', 'I', 'saw', 'Elba')
    >>> split('able was I ere I saw Elba', 'a')
        ('', 'ble w', 's I ere I s', 'w Elb', '')
    """
    ss = ()
    ...
    return ss


# 8.
def mode(xs):
    """
    Returns a pair of values indicating the "mode" of a nonempty tuple (of
    orderable values). The first item in the pair is the most commonly
    occurring value in xs, the second is the number of times that value occurs.
    If there is a tie, the least item (in terms of the usual less-than
    ordering) occurring that occurs the most times (and its count) is returned.

    >>> mode((9, 4, 3, 4, 3, 7))
    (3, 2)
    >>> mode(('a', 'b', 'c', 'b', 'a', 'b'))
    ('b', 3)
    """
    ordered = insertion_sort(xs)   # any kind of sorting will do
    max_value = ordered[0]
    max_count = 1
    ...
    return (max_value, max_count)


# 9.
# Returns the elapsed time in nanoseconds to execute function f on input x,
# reps times. Assumes f is a function that takes a single argument.
def time_it(f, x, reps):
    ...
    return ...


# 10.
# Return a tuple of n triples where each triple is of the form
#  (size, selection-sort-time, insertion-sort-time)
#
# size begins at start, and doubles each iteration; selection-sort-time is the
# nanoseconds required to sort a random tuple of size numbers; and likewise for
# insertion-sort-time
#
# so the data might look like:
# >>> sort_compare(5, 10)
#    ((10, 47166, 25708), (20, 214792, 27875), (40, 134417, 85541),
#     (80, 371792, 254417), (160, 1269250, 949834))
def sort_compare(n, start):
    triples = ()
    size = start
    for _ in range(n):
        ...
    return triples
